#ifndef _CAVE_H_
#define _CAVE_H_


#define CAVE_POSITION(x,y)   ((x) + (y) * CAVE_WIDTH)

enum CAVE_mask_flags
{
   CAVE_MASK_INC   = 0x0001,
   CAVE_MASK_DEC   = 0x0002,
   CAVE_MASK_CLEAR = 0x0004,
   CAVE_MASK_FADE  = 0x0008
};


struct COORDINATE
{
   short x;
   short y;
};

struct CAVE_DATA
{
   short  room;			/* Cave number                              */
   short  level;		/* Level number                             */
   long   wall_time;		/* Magic wall milling time                  */
   long   amoeba_time;		/* Max amoeba time at 3% growth             */
   short  dvalue_init;		/* Initial diamond value                    */
   short  dvalue_extra;		/* Extra diamond value                      */
   short  diamonds;		/* Diamonds needed on difficulty levels 1-5 */
   long   time;			/* Cave time for difficulty levels 1-5      */
   short  color[3];		/* Cave colors                              */
   unchar data[CAVE_SIZE];	/* Cave data                                */
   unchar attr[CAVE_SIZE];	/* Cave data attributes                     */
   unchar anim[CAVE_SIZE];	/* Cave data animation frame                */
};


extern struct COORDINATE cave_max, cave_offset, cave_out;
extern struct CAVE_DATA  cave;


#if defined (__STDC__) || defined (__cplusplus) || defined (NeedFunctionPrototypes)
#define __PARMS(s) s
#else
#define __PARMS(s) ()
#endif

void  coords_clear           __PARMS((struct COORDINATE *coord));
void  cave_set_position      __PARMS((short position, unchar object, unchar attr, unchar anim));
void  cave_exchange_position __PARMS((short new_position, short old_position));
void  cave_next              __PARMS((void));
short cave_load              __PARMS((short cave_room, short cave_level));
void  cave_mask              __PARMS((short mask_flag));
void  cave_show              __PARMS((void));
void  cave_mask_set          __PARMS((short mask_flag, time_t move_time));

#undef __PARMS
#endif /* _CAVE_H_ */
